
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h> 
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <strings.h>
#include <unistd.h>

#include "Event.h"


int registerApp(int AID, int port) {
   
  int sockfd;
  struct sockaddr_in serv_addr;
  char *tmp;
  int q;
  
 

  bzero ((char *) &serv_addr, sizeof(serv_addr));
  serv_addr.sin_family = PF_INET;
  serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  serv_addr.sin_port = htons(port);

  if ( (sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
    
   perror("socket");
   exit(0);
  }
       
  if (connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {

   perror("connect");
   exit(0);
  }

   tmp = (char *) &AID;

   q = write(sockfd, tmp, 4);     
   if (q == -1) {
     perror("write"); 
     exit(0);
   }
  
  return sockfd;
}



void sendEvent(int sockfd, struct Event *e) {
  
  char *tmp;
  int d;
  int q;

  d = e ->type;
  tmp = (char *) &d;
  
  q = write(sockfd, tmp, 4);
  
  if (q == -1) {
    perror("write");
    exit(0);
  }
/* d = e->AID; */
/*   tmp = (char *) &d; */

/*   q = write(sockfd, tmp, 4); */
/*   if (q == -1)  */
/*     perror("write"); */
  
  d = e->len;
  tmp = (char *) &d;

  q = write(sockfd, tmp, 4);
  if (q == -1) {
    perror("write");
    exit(0);
  }
  
  q = write(sockfd, e->data, getLen(e));
  if (q == -1) {
    perror("write");
    exit(0);
  }

}


struct Event *receiveEvent(int sockfd) {

  char tmp[4];
  int *a;
  int type;
  int len;
  char *data;
  struct Event *r;
  int i;
  int q;


 /*  for (i = 0; i < 4; i ++)  {  */
/*      q = read(sockfd, &tmp[i], 1);  */
   
/*      if (q == -1) */
/*        perror("read");  */
/*   }  */

  for (i = 0; i < 4; i ++) {
   
    q = read(sockfd, &tmp[i], 1);
    if (q == -1) {
       perror("read"); 
       exit(0);
    }

    if (q == 0) {

      return NULL;
    }
  }
 

  a = (int *) tmp;

  type = *a;
 
  for (i = 0; i < 4; i ++) {
   
    q = read(sockfd, &tmp[i], 1);
    if (q == -1) {
       perror("read"); 
       exit(0);
    }
    if (q == 0) {

      return NULL;
    }
  }
  
  a = (int *) tmp;

  len = *a;

  data = (char *) malloc(len * sizeof(char));

  for( i = 0; i < len; i ++) { 
    q = read(sockfd, &data[i], 1);
    if (q == -1) {
       perror("read"); 
       exit(0);
    }
    if (q == 0) {

      return NULL;
    }
  }

  r = createEvent(type, len, data);

  free(data);

  return r;
  
  
 
}

struct Event *createEvent(int type, int len, char *data) {
  
  int i;
  struct Event *result;

  result = (struct Event *) malloc(sizeof(struct Event));
  
  result->type = type;
  result->len = len;

  result->data = (char *) malloc(len * sizeof(char));

  for (i = 0; i < len; i ++) 
    result->data[i] = data[i];

  return result;

}

void destroyEvent(struct Event *e) {
  
 
  free(e->data);
  free(e);

  e = NULL;
  
}


int getType(struct Event *e) {

  return e->type;

}

int getLen(struct Event *e) {
  
  return e->len;
}

char *getData(struct Event *e) {

  int lentmp;
  int i;
  char *R;



  lentmp = getLen(e);

  R = (char *) malloc(lentmp * sizeof(char));


  for(i = 0; i < lentmp; i ++) 

    R[i] = e->data[i];

  
  return R;

}






